<?php
namespace Plaintracker1;

class Lib_Q
{
	private $where = [];
	private $orderBy = [];
	private $limit;
	private $offset;

	public static function construct()
	{
		$ret = new static;
		return $ret;
	}

	public function clearWhere()
	{
		$this->where = [];
		return $this;
	}

	public function isWhereSet( $name )
	{
		$ret = FALSE;

		foreach( $this->where as $q ){
			if( $name == $q[0] ){
				$ret = TRUE;
				break;
			}
		}

		return $ret;
	}

	public function orderBy( $name, $direction = 'ASC' )
	{
		$this->orderBy[] = [ $name, $direction ];
		return $this;
	}

	public function getOrderBy()
	{
		return $this->orderBy;
	}

	public function where( $prop, $compare, $v )
	{
		$this->where[] = [ $prop, $compare, $v ];
		return $this;
	}

	public function unsetWhere( $prop )
	{
		$ids = array_keys( $this->where );
		$count = count( $ids );
		for( $ii = ($count - 1); $ii >= 0; $ii-- ){
			$id = $ids[$ii];
			if( $prop !== $this->where[$id][0] ) continue;
			unset( $this->where[$id] );
		}
		return $this;
	}

	public function getWhere()
	{
		return $this->where;
	}

	public function getWhereByProp()
	{
		$ret = [];
		foreach( $this->where as $w ){
			list( $prop, $compare, $value ) = $w;
			if( ! isset($ret[$prop]) ) $ret[$prop] = [];
			$ret[$prop][$compare] = $value;
		}
		return $ret;
	}

	public function limit( $qty )
	{
		$this->limit = $qty;
		return $this;
	}

	public function getLimit()
	{
		return $this->limit;
	}

	public function offset( $qty )
	{
		$this->offset = $qty;
		return $this;
	}

	public function getOffset()
	{
		return $this->offset;
	}

	public static function check( $obj, self $q )
	{
		$where = $q->getWhere();

	// AND GROUP
		$ret = TRUE;

		foreach( $where as $w ){
			$thisRet = static::checkOne( $obj, $w );
			if( ! $thisRet ){
				$ret = FALSE;
				break;
			}
		}

		if( ! $ret ) return $ret;

		return $ret;
	}

	public function filter( array $objects, self $q )
	{
		$ret = array();
		foreach( $objects as $id => $obj ){
			if( ! $this->check($obj, $q) ) continue;
			$ret[ $id ] = $obj;
		}

		return $ret;
	}

	public static function checkOne( $obj, $cond )
	{
		$ret = FALSE;
		list( $k, $compare, $to ) = $cond;

		if( is_array($obj) ){
			if( ! array_key_exists($k, $obj) ){
				$ret = TRUE;
				return $ret;
			}
			
		}
		else {
			// if( ! property_exists($obj, $k) ){
				// $ret = TRUE;
				// return $ret;
			// }
		}

		if( is_array($obj) ){
			$v = $obj[$k];
		}
		else {
			$v = $obj->{$k};
		}

		if( NULL === $v ){
			$ret = TRUE;
			return $ret;
		}

		switch( $compare ){
			case '=':
				if( is_array($to) ){
					if( is_array($v) ){
						$ret = array_intersect($v, $to) ? TRUE : FALSE;
					}
					else {
						$ret = in_array( $v, $to );
					}
				}
				else {
					if( is_array($v) ){
						$ret = in_array( $to, $v );;
					}
					else {
						$ret = ( $v == $to );
					}
				}
				break;

			case '<>':
				if( is_array($to) ){
					$ret = ! in_array( $v, $to );
				}
				else {
					$ret = ( $v != $to );
				}
				break;

			case '>':
				$ret = ( $v > $to );
				break;

			case '&':
				$ret = ( $v & $to );
				break;

			case '>=':
				$ret = ( $v >= $to );
				break;

			case '<':
				$ret = ( $v < $to );
				break;

			case '<=':
				$ret = ( $v <= $to );
				break;

			case 'LIKE':
				$ret = ( FALSE === strpos($v, $to) ) ? FALSE : TRUE;
				break;

			default:
				exit( __METHOD__ . ": unknown compare: '$compare'" );
				break;
		}

		return $ret;
	}

	public function __set( $name, $value )
	{
		$msg = 'Invalid property for setting: ' . get_class($this) . ': ' . $name . '<br>';
		error_log( $msg );
	}

	public function __get( $name )
	{
		$msg = 'Invalid property for getting: ' . get_class($this) . ': ' . $name . '<br>';
		error_log( $msg );
	}
}