<?php
namespace Plaintracker1;

class Model_Activity extends Lib_ModelSql
{
	const STATE_ACTIVE = 'active';
	const STATE_ARCHIVE = 'archive';

	public static function table()
	{
		$ret = '__activity';
		return $ret;
	}

	public static function fields()
	{
		$ret = [
			'id'			=> [ 'type' => 'INTEGER',			'null' => FALSE,	'auto_increment' => TRUE, 'key' => TRUE ],
			'title'		=> [ 'type' => 'VARCHAR(255)',	'null' => FALSE ],
			'state'		=> [ 'type' => 'VARCHAR(16)',		'null' => FALSE, 'default' => static::STATE_ACTIVE ],
			'state'		=> [ 'type' => 'VARCHAR(16)',		'null' => FALSE ],
			'user_id'	=> [ 'type' => 'INTEGER',			'null' => TRUE ],
		];
		return $ret;
	}

	public static function construct()
	{
		return M_Activity::construct();
	}

	public static function q()
	{
		$q = parent::q();
		$q->orderBy( 'title' );
		return $q;
	}

	public static function stateOptions()
	{
		$ret = [ M::STATE_ACTIVE, M::STATE_ARCHIVE ];
		return $ret;
	}

	public static function delete( $m )
	{
		parent::delete( $m );

	// delete records
		$q = Model_Record::q();
		$q->where( 'activity_id', '=', $m->id );
		Model_Record::deleteMany( $q );
	}
}