<?php
namespace Plaintracker1;

class Model_Setting extends Lib_ModelSql
{
	static $loaded = NULL;

	public static function defaults()
	{
		$ret = [];

		$ret['time_week_starts'] = 0;
		$ret['time_time_format'] = 'g:ia';
		$ret['time_date_format'] = 'j M Y';

		$ret = apply_filters( __METHOD__, $ret );
		return $ret;
	}

	public static function table()
	{
		$ret = '__setting';
		return $ret;
	}

	public static function fields()
	{
		$ret = [
			'id'		=> [ 'type' => 'VARCHAR(64)',		'null' => FALSE, 'key' => TRUE ],
			'value'	=> [ 'type' => 'TEXT',				'null' => TRUE ],
		];
		return $ret;
	}

	public static function get( $id )
	{
		if( NULL === static::$loaded ){
			$q = static::q();
			$data = static::load( $q );
			static::$loaded = [];
			foreach( $data as $e ){
				static::$loaded[ $e['id'] ] = $e['value'];
			}
		} 

		$values = static::$loaded + static::defaults();
		$ret = array_key_exists( $id, $values ) ? $values[ $id ] : NULL;

		return $ret;
	}

	public static function set( $id, $value )
	{
		if( NULL === static::$loaded ){
			$q = static::q();
			static::$loaded = static::load( $q );
		} 

		$newM = [ 'id' => $id, 'value' => $value ];

		if( array_key_exists($id, static::$loaded) ){
			if( $value != static::$loaded[$id] ){
				$oldM = [ 'id' => $id, 'value' => static::$loaded[$id] ];
				static::update( $oldM, $newM );
				static::$loaded[$id] = $value;
			}
		}
		else {
			$newM = [ 'id' => $id, 'value' => $value ];
			static::create( $newM );
		}

		return $value;
	}
}