<?php
namespace Plaintracker1;

class Page_ActivityId
{
	public static function title()
	{
		$ret = '__Edit Activity__';
		return $ret;
	}

	public static function menu( array $x )
	{
		$ret = [];
		$ret[ 'activity' ] = '&larr; ' . '__Activities__';
		$ret[ 'activity-' . $x[0] . '-delete' ] = '&times; ' . '__Delete__';
		return $ret;
	}

	public function postTitle( Context $x )
	{
		$ret = '__Activity Updated__';
		return $ret;
	}

	public static function get( array $x )
	{
		$id = $x[0];
		$m = Model_Activity::findById( $id );
		if( ! $m ) return $x;

		$x['$m'] = $m;

	// ui
		$x['input-title'] = Lib_Html::inputText( 'title', $m->title );
		$x['input-title']['validate'][] = Lib_Html::validatorRequired();
		$x['input-title']['validate'][] = Lib_Html::validatorUniqueProp([
			'class' => Model_Activity::class,
			'prop' => 'title',
			'skip' => $m->id,
		]);

		$x['input-is_archive'] = Lib_Html::inputCheckbox( 'is_archive', Model_Activity::STATE_ARCHIVE == $m->state ? 1 : 0 );

		return $x;
	}

	public static function post( array $x, array $values )
	{
		$archived = $values['is_archive'] ? TRUE : FALSE;
		unset( $values['is_archive'] );

		$m = $x[ '$m' ];
		$newM = clone $m;
		foreach( $values as $k => $v ){
			$newM->{$k} = $v;
		}
		$newM->state = $archived ? $m::STATE_ARCHIVE : $m::STATE_ACTIVE;

		$m = Model_Activity::update( $m, $newM );
		$x['redirect'] = 'activity';

		return $x;
	}

	public static function render( array $x )
	{
?>

<form method="post">

<div>
	<div>
		<label for="<?php echo esc_attr( Lib_Html::id($x['input-title']) ); ?>">__Activity Name__</label>
	</div>

	<div>
		<?php Lib_Html::render( $x['input-title'] ); ?>
	</div>
</div>

<div>
	<div>
		<label>
			<?php Lib_Html::render( $x['input-is_archive'] ); ?>__Archived?__
		</label>
	</div>
</div>

<div>
	<div>
		<button type="submit" class="button button-primary">__Update Activity__</button>
	</div>
</div>

</form>

<?php
	}
}