<?php
namespace Plaintracker1;

class Page_Record
{
	public static function title( array $x )
	{
		$date = isset( $x['date'] ) ? $x['date'] : Lib_Time::instance()->setNow()->getDateDb();

		$ret = Lib_TimeFormat::formatMonthYear( $date );
		$ret = Lib_TimeFormat::formatDateWithWeekday( $date );

		return $ret;
	}

	public static function menu( array $x )
	{
		$ret = [];
		$ret[ 'record-new' ] = '__Add New Record__';
		return $ret;
	}

	public static function get( array $x )
	{
		$t = Lib_Time::instance();

		$date = isset( $x['date'] ) ? $x['date'] : $t->setNow()->getDateDb();

		$q = Model_Activity::q();
		$q->where( 'user_id', '=', $x['$currentUserId'] );
		$activities = Model_Activity::find( $q );

		if( ! $activities ){
			$x->redirect = 'activity-new';
			return $x;
		}

		$x[ '$activities' ] = $activities;

		$activityIds = array_keys( $activities );

		$qBlueprint = Model_Record::q();
		$qBlueprint->where( 'activity_id', '=', $activityIds );

	// this week
		$q = clone $qBlueprint;
		$start = $t->setDateDb( $date )->setStartWeek()->getDateDb();
		$end = $t->setEndWeek()->getDateDb();
		$q->where( 'date', '>=', $start );
		$q->where( 'date', '<=', $end );
		$modelsThisWeek = Model_Record::find( $q );

	// last week
		$q = clone $qBlueprint;
		$start = $t->setDateDb( $date )->setStartWeek()->modify('-1 day')->setStartWeek()->getDateDb();
		$end = $t->setEndWeek()->getDateDb();
		$q->where( 'date', '>=', $start );
		$q->where( 'date', '<=', $end );
		$modelsLastWeek = Model_Record::find( $q );

	// this year
		$q = clone $qBlueprint;
		$start = $t->setDateDb( $date )->setStartYear()->getDateDb();
		$end = $t->setEndYear()->getDateDb();
		$q->where( 'date', '>=', $start );
		$q->where( 'date', '<=', $end );
		$modelsThisYear = Model_Record::find( $q );

	// last year
		$q = clone $qBlueprint;
		$start = $t->setDateDb( $date )->modify( '-1 year' )->setStartYear()->getDateDb();
		$end = $t->setEndYear()->getDateDb();
		$q->where( 'date', '>=', $start );
		$q->where( 'date', '<=', $end );
		$modelsLastYear = Model_Record::find( $q );

		$x[ '$modelsThisWeek' ] = $modelsThisWeek;
		$x[ '$modelsLastWeek' ] = $modelsLastWeek;
		$x[ '$modelsThisYear' ] = $modelsThisYear;
		$x[ '$modelsLastYear' ] = $modelsLastYear;

		return $x;
	}

	public static function render( array $x )
	{
		$activities = $x[ '$activities' ];
		$t = Lib_Time::instance();

		$thisWeek = [];
		$modelsThisWeek = $x[ '$modelsThisWeek' ];
		foreach( $modelsThisWeek as $m ){
			if( ! isset($thisWeek[$m->activity_id]) ) $thisWeek[$m->activity_id] = 0;
			$thisWeek[$m->activity_id] += $m->qty;
		}

		$lastWeek = [];
		$modelsLastWeek = $x[ '$modelsLastWeek' ];
		foreach( $modelsLastWeek as $m ){
			if( ! isset($lastWeek[$m->activity_id]) ) $lastWeek[$m->activity_id] = 0;
			$lastWeek[$m->activity_id] += $m->qty;
		}

		$thisYear = [];
		$modelsThisYear = $x[ '$modelsThisYear' ];
		foreach( $modelsThisYear as $m ){
			if( ! isset($thisYear[$m->activity_id]) ) $thisYear[$m->activity_id] = 0;
			$thisYear[$m->activity_id] += $m->qty;
		}

		$today = $t->setNow()->getDateDb();
		$startYear = $t->setNow()->setStartYear()->getDateDb();
		$thisYearDays = $t->getDifferenceInDays( $startYear, $today );
		$thisYearWeeks = floor( $thisYearDays/ 7 );

		$lastYear = [];
		$models = $x[ '$modelsLastYear' ];
		foreach( $models as $m ){
			if( ! isset($lastYear[$m->activity_id]) ) $lastYear[$m->activity_id] = 0;
			$lastYear[$m->activity_id] += $m->qty;
		}
		$lastYearWeeks = 52;
?>

<table>
	<thead>
		<tr>
			<th>
				__Activity__
			</th>
			<th class="pw-col-2 pw-align-center">
				__This Week__<br/><small>__Total__<small>
			</th>
			<th class="pw-col-2 pw-align-center">
				__Last Week__<br/><small>__Total__<small>
			</th>
			<th class="pw-col-2 pw-align-center">
				__This Year__<br/><small>__Total__/__Average__<small>
			</th>
			<th class="pw-col-2 pw-align-center">
				__Last Year__<br/><small>__Total__/__Average__<small>
			</th>
		</tr>
	</thead>

	<tbody>
		<?php foreach( $activities as $m ) : ?>
		<tr>
			<td>
				<?php echo esc_html( $m->title ); ?>
			</td>

			<td class="pw-align-center">
				<?php
				$total = isset($thisWeek[$m->id]) ? $thisWeek[$m->id] : 0;
				?>
				<?php if( $total ) : ?><?php echo esc_html( $total ); ?><?php endif; ?>
			</td>

			<td class="pw-align-center">
				<?php
				$total = isset($lastWeek[$m->id]) ? $lastWeek[$m->id] : 0;
				?>
				<?php if( $total ) : ?>
					<?php echo esc_html( $total ); ?>
				<?php endif; ?>
			</td>
			<td class="pw-align-center">
				<?php
				$total = isset($thisYear[$m->id]) ? $thisYear[$m->id] : 0;
				$average = $total / $thisYearWeeks;
				$average = sprintf( "%.2f", $average )
				?>
				<?php if( $total ) : ?><?php echo esc_html( $total ); ?> / <?php echo esc_html( $average ); ?><?php endif; ?>
			</td>
			<td class="pw-align-center">
				<?php
				$total = isset($lastYear[$m->id]) ? $lastYear[$m->id] : 0;
				$average = $total / $lastYearWeeks;
				$average = sprintf( "%.2f", $average )
				?>
				<?php if( $total ) : ?><?php echo esc_html( $total ); ?> / <?php echo esc_html( $average ); ?><?php endif; ?>
			</td>
		</tr>
		<?php endforeach; ?>
	</tbody>
</table>

<?php
	}
}