<?php
namespace Plaintracker1;

class Page_RecordNew
{
	public static function title( array $x )
	{
		return '__New Record__';
	}

	public static function menu( array $x )
	{
		$ret = [];
		$ret[ 'record' ] = '&larr; ' . '__Records__';
		return $ret;
	}

	public function postTitle( Context $x )
	{
		return '__Record Created__';
	}

	public static function post( array $x, array $values )
	{
		$models = [];

		$m = $x[ '$m' ];
		foreach( $values as $k => $v ){
			$m->{$k} = $v;
		}

		$models[] = $m;

		$created = [];
		foreach( $models as $m ){
			$m = Model_Record::create( $m );
			$created[ $m->id ] = $m;
		}

		$x['redirect'] = 'record';
		return $x;
	}

	public static function get( array $x )
	{
		$t = Lib_Time::instance();

	// data
		$date = isset( $x['date'] ) ? $x['date'] : $t->setNow()->getDateDb();

		$m = Model_Record::construct();
		$m->date = $date;

		$x[ '$m' ] = $m;
		$x[ '$date' ] = $date;

	// date
		$x['input-date'] = Lib_Html::inputDate( 'date', $m->date );
		$x['input-date']['validate'][] = Lib_Html::validatorRequired();

	// activity_id
		$q = Model_Activity::q();
		$q->where( 'state', '=', Model_Activity::STATE_ACTIVE );
		$q->where( 'user_id', '=', $x['$currentUserId'] );
		$activities = Model_Activity::find( $q );

		$option = [];
		foreach( $activities as $e ){
			$option[ $e->id ] = $e->title;
		}

		$options = array_keys( $option );
		$m->activity_id = current( $options );

		$x['input-activity_id'] = Lib_Html::inputRadioSet( 'activity_id', $m->activity_id, $option );
		$x['input-activity_id']['validate'][] = Lib_Html::validatorRequired();

	// qty
		$x['input-qty'] = Lib_Html::inputText( 'qty', $m->qty );
		$x['input-qty']['validate'][] = Lib_Html::validatorRequired();

		return $x;
	}

	public static function render( array $x )
	{
?>

<form method="post">

<div>
	<div>
		__Date__
	</div>
	<div>
		<?php Lib_Html::render( $x['input-date'] ); ?>
	</div>
</div>

<div>
	<div>
		__Activity__
	</div>
	<div>
		<?php Lib_Html::render( $x['input-activity_id'] ); ?>
	</div>
</div>

<div>
	<div>
		<label for="<?php echo esc_attr( Lib_Html::id($x['input-qty']) ); ?>">__Quantity__</label>
	</div>
	<div>
		<?php Lib_Html::render( $x['input-qty'] ); ?>
	</div>
</div>

<div>
	<div>
		<button type="submit" class="button button-primary">__Add New Record__</button>
	</div>
</div>

</form>

<?php
	}
}