<?php
namespace Plaintracker1;

class Page_SettingTime
{
	public static function title( array $x )
	{
		$ret = '__Date & Time__';
		return $ret;
	}

	public static function menu( array $x )
	{
		$ret = [];
		$ret['setting'] = '&larr; ' . '__Settings__';
		return $ret;
	}

	public static function post( array $x, array $values )
	{
		foreach( $values as $k => $v ){
			Model_Setting::set( $k, $v );
		}
		$x[ 'redirect' ] = 'setting-time';
		return $x;
	}

	public static function get( array $x )
	{
	// time_date_format
		$option = [
			'j M Y',

			'n/j/Y',
			'm/d/Y',
			'm-d-Y',
			'm.d.Y',

			'j/n/Y',
			'd/m/Y',
			'd-m-Y',
			'd.m.Y',

			'Y/m/d',
			'Y-m-d',
			'Y.m.d',
			];

		$option = array_flip( $option );
		foreach( array_keys($option) as $k ){
			$option[$k] = date($k);
		}
		$x[ 'input-time_date_format' ] = Lib_Html::inputSelect( 'time_date_format', Model_Setting::get('time_date_format'), $option );

	// time_time_format
		$option = [ 'g:ia', 'g:i A', 'H:i' ];
		$option = array_flip( $option );
		foreach( array_keys($option) as $k ){
			$option[$k] = date($k);
		}
		$x[ 'input-time_time_format' ] = Lib_Html::inputRadioSet( 'time_time_format', Model_Setting::get('time_time_format'), $option );

	// time_week_starts
		$option = [ '0' => '__Sun__', '1' => '__Mon__' ];
		$x[ 'input-time_week_starts' ] = Lib_Html::InputSelect( 'time_week_starts', Model_Setting::get('time_week_starts'), $option );

		return $x;
	}

	public static function render( array $x )
	{
?>

<form method="post">

<div>
	<div>
		<label for="<?php echo esc_attr( Lib_Html::id($x['input-time_date_format']) ); ?>">__Date Format__</label>
	</div>
	<div>
		<?php Lib_Html::render( $x['input-time_date_format'] ); ?>
	</div>
</div>

<div>
	<div>
		<label for="<?php echo esc_attr( Lib_Html::id($x['input-time_time_format']) ); ?>">__Time Format__</label>
	</div>
	<div>
		<?php Lib_Html::render( $x['input-time_time_format'] ); ?>
	</div>
</div>

<div>
	<div>
		<label for="<?php echo esc_attr( Lib_Html::id($x['input-time_week_starts']) ); ?>">__Week Starts On__</label>
	</div>
	<div>
		<?php Lib_Html::render( $x['input-time_week_starts'] ); ?>
	</div>
</div>

<div>
	<div>
		<button class="button button-primary">__Save__</button>
	</div>
</div>

</form>

<?php
	}
}