<?php
namespace Plaintracker1;

class Page_ToolExport
{
	public static function title( array $x )
	{
		return '__Export__';
	}

	public static function menu( array $x )
	{
		$ret = [];
		$ret['tool'] = '&larr; ' . '__Tools__';
		return $ret;
	}

	public static function get( array $x )
	{
	// fields
		$option = [ 'date' => '__Date__', 'activity' => '__Activity Name__', 'qty' => '__Quantity__' ];
		$values = array_keys( $option );
		for( $ii = 1; $ii <= 3; $ii++ ){
			$x[ 'input-field' . $ii ] = Lib_Html::inputSelect( 'field' . $ii, $values[ $ii-1 ], $option );
		}

	// separator
		$option = [ ',' => ',', ';' => ';', 's' => '__Space__' ];
		$values = array_keys( $option );
		$x['input-separator'] = Lib_Html::inputSelect( 'separator', current($values), $option );
		$x['input-separator']['validate'][] = Lib_Html::validatorRequired();

	// output options
		$option = [ 'print' => '__Print On Screen__', 'download' => '__Download File__' ];
		$values = array_keys( $option );
		$x['input-output'] = Lib_Html::inputRadioSet( 'output', current($values), $option );

		return $x;
	}

	public static function post( array $x, array $values )
	{
		$q = Model_Activity::q();
		$q->where( 'state', '<>', NULL );
		$activities = Model_Activity::find( $q );

		$separator = $values['separator'];
		$fields = [ $values['field1'], $values['field2'], $values['field3'] ];
		$output = $values['output'];

		$q = Model_Record::q();
		$models = Model_Record::find( $q );

		$lines = [];

		foreach( $models as $m ){
			$line = [];
			foreach( $fields as $f ){
				if( ('activity' == $f) && ( ! isset($activities[$m->activity_id]) ) ) continue;

				switch( $f ){
					case 'activity':
						$activity = $activities[ $m->activity_id ];
						$v = $activity->title;
						break;
					default:
						$v = $m->{$f};
						break;
				}
				$line[ $f ] = $v;
			}

			$line = join( $separator, $line );
			$lines[] = $line;
		}

		$ret = join( "\n", $lines );
		$ret = trim( $ret );

	// print
		if( 'print' == $output ){
			echo nl2br( esc_html($ret) );
			exit;
		}

	// download
		// $this->t->setNow();
		$fileName = [];
		$fileName[] = 'plaintracker';
		// $fileName[] = $this->t->getDateDb();
		// $fileName[] = $this->t->getTimeDb();
		$fileName = join( '-', $fileName ) . '.txt';

	// it'll exit there anyway
		Lib_Html::downloadData( $fileName, $ret );
		exit;
	}

	public static function render( array $x )
	{
?>

<form method="post">

<div>
	<div>__Fields__</div>
	<div>
		<div class="pw-grid">
			<?php for( $ii = 1; $ii <= 3; $ii++ ) : ?>
				<div class="pw-col-1-3">
					<label><span>__Field__ #<?php echo esc_html($ii); ?></span><br/><?php Lib_Html::render( $x['input-field' . $ii] ); ?></label>
				</div>
			<?php endfor; ?>
		</div>
	</div>
</div>

<div>
	<div>
		<label for="<?php echo esc_attr( Lib_Html::id($x['input-separator']) ); ?>">__Separate By__</label>
	</div>
	<div><?php Lib_Html::render( $x['input-separator'] ); ?></div>
</div>

<div>
	<div>
		__Output__
	</div>
	<div><?php Lib_Html::render( $x['input-output'] ); ?></div>
</div>

<div>
	<div>
		<button type="submit" class="button button-primary">__Export Records__</button>
	</div>
</div>

</form>

<?php
	}
}